@page CHANGES-2-8 Version 2.8
  
## Version 2.8 (under development)

This page contains changes that will end up in 2.8

- Changes leading to differences with previous versions
  - in \ref METAD if possible the root walker in WALKERS_MPI will set the folder from which reading the GRID/HILLS file upon restart
  - in \ref METAD work is not calculated by default anymore, if needed it can be obtained using CALC_WORK
  - in \ref METAD an error will be thrown if when restarting from FILE the file is not found

- New actions:
  - \ref GHBFIX to compute generalized hydrogen-bond fixes

- New contributed module:
  - A new SASA module by Andrea Arsiccio
     - \ref SASA_HASEL
     - \ref SASA_LCPO

- Other improvements
  - in \ref METAD a new keyword NLIST has been added to use a neighbor list for bias evaluation, this should be faster than grids with many CVs
  - in \ref METAD there are more checks that a restart of WALKERS_MPI is working consistently among walkers
  - in \ref driver there is a flag `--restart` that can be used to enforce restart (similar to using \ref RESTART in the PLUMED input file).
  - Added configure option `--enable-cxx`. Can be used to select C++14 with `--enable-cxx=14`. Required to compile against libraries
    whose header files need C++14.

- Changes in the OPES module
  - new action \ref OPES_EXPANDED
  - various new actions of type \ref EXPANSION_CV to be used with \ref OPES_EXPANDED
  - new action \ref OPES_METAD_EXPLORE

- For developers:
  - The C++ interface now performs type checking (see https://github.com/plumed/plumed2/pull/653).
    This should require no change for MD codes that were calling PLUMED with correct arguments.
    Checks could be disabled at runtime with `export PLUMED_TYPESAFE_IGNORE=yes`.
  - Two new Fortran modules have been added. One of them provides explicit interfaces for the already available wrappers.
    With no change in calling code, just by including this module, one could perform runtime type/shape checking.
    In addition, a novel object oriented Fortran interface has been designed which allow to better manipulate
    PLUMED instances from Fortran.
    Both interface were written with a significant help from Balint Aradi.
  - `xxd` replaced by a awk script. This removed the build dependence on vim.
  - Lepton has been updated with OpenMM 7.5.1.
